Page MenuHomePhabricator

Add textshares to ArticleInfo
Closed, ResolvedPublic

Description

The lack of "textshares" is the only thing that WikiHistory does that XTools does not. WikiHistory is very popular in the dewiki community and they are asking to get the same textshare data. This was part of a wish on the Technical Wishlist Survey.

Textshares can be described as a list of editors to an article, with percentages representing how much of the article they authored. This is broadly related to the "Added (bytes)" column of the "Top editors" section, but I think textshares might be more complicated. There is some older code to go off of.

Event Timeline

MusikAnimal moved this task from Inbox to Other on the XTools board.

Haha of course there's a goat token! ty =P

MusikAnimal added a subscriber: JStrodt_WMDE.EditedSep 28 2017, 2:04 AM

@JStrodt_WMDE So I take back what I said via email... while this wouldn't be terribly difficult to implement, it will be very expensive. The gadget runs queries on every page. The ArticleInfo gadget gives you quick statistics that we can fetch in real time, in under a second. But for textshares, we have to go through every revision in the article. This will be too slow for an API.

I was wondering how WikiHistory did this, and now I recall -- it computes the textshare information ahead of time with a bot, and stores it in a database. This allows you to quickly get the textshares for a given article, provided the bot isn't broken. XTools does not feature such a bot, and it's highly unlikely we would implement something like this :/ A bot seems fragile, and also XTools is meant to work on all wikis (even non-WMF wikis), not just the few wikis we have the bot running on.

So I'm sorry to say the gadget idea probably won't happen from us :( But I can still make the actual ArticleInfo tool (not the gadget) show the textshare percentages just like WikiHistory did. Even as it is now, you can still see the "Top editors" of an article using XTools (example). You'll just have to ask for the data on-demand using a link, rather than have it show up directly on the wiki page. I see you're already linking to ArticleInfo in MediaWiki:Pageinfo-footer (shown on the action=info page). For further convenience, you might add the link to MediaWiki:Wikimedia-copyright just like you are doing with the Pageviews link.

MusikAnimal lowered the priority of this task from Normal to Low.Sep 30 2017, 4:23 PM
MusikAnimal renamed this task from Add textshares to ArticleInfo, and a separate API endpoint to Add textshares to ArticleInfo.Oct 19 2017, 6:59 PM
MusikAnimal raised the priority of this task from Low to Normal.
MusikAnimal moved this task from Other to Pending deployment on the XTools board.
MusikAnimal closed this task as Resolved.EditedJan 12 2018, 11:28 PM
MusikAnimal moved this task from Pending deployment to Complete on the XTools board.

Deployed! We are now showing accurate authorship attribution, thanks to kind people who created Wikiwho. Right now they only support a handful of Wikipedias, but they say they are working to add support for more.

I am using the term "authorship" instead of textshares, as that is more easy to understand, I think.

See https://xtools.wmflabs.org/articleinfo/de.wikipedia.org/Bottmingen#authorship for an example.

There is also a dedicated page with the full results at https://xtools.wmflabs.org/articleinfo-authorship/de.wikipedia.org/Bottmingen.

Courtesy ping @JStrodt_WMDE 🐐